#include <stdio.h>
#include <string.h>

#include <timer.h>

#include <aversive/wait.h>
#include <uart.h>

#include "i2cm_sw.h"

uint8_t read_reg(uint8_t address_dev, uint8_t address_reg, uint8_t * value)
{
	uint8_t err = 0;
	err = i2cm_send(address_dev, &address_reg, 1);
	if (err) {
		printf("read reg: i2c error send\r\n");
		return err;
	}
	err = i2cm_recv(address_dev, 1);
	if (err) {
		printf("read reg: i2c error recv\r\n");
		return err;
	}
	err = i2cm_get_recv_buffer(value, 1);
	if (err != 1) {
		printf("read reg: i2c error get recv\r\n");
		return 0xff;
	}
	return 0;

}


uint8_t read_reg_len(uint8_t address_dev, uint8_t address_reg,
	uint8_t *values, uint8_t len)
{
	uint8_t err = 0;
	err = i2cm_send(address_dev, &address_reg, 1);
	if (err) {
		printf("read reg len: i2c error send\r\n");
		return err;
	}
	err = i2cm_recv(address_dev, len);
	if (err) {
		printf("read reg len: i2c error recv\r\n");
		return err;
	}
	err = i2cm_get_recv_buffer(values, len);
	if (err != len) {
		printf("read reg len: i2c error get recv\r\n");
		return 0xFF;
	}
	return 0;

}
