#ifndef I2CM_SW_H
#define I2CM_SW_H

/*
#define BIT(x) (1 << (x))
#define SETBITS(x,y) ((x) |= (y))
#define CLEARBITS(x,y) ((x) &= (~(y)))
#define SETBIT(x,y) SETBITS((x), (BIT((y))))
#define CLEARBIT(x,y) CLEARBITS((x), (BIT((y))))
#define BITSET(x,y) ((x) & (BIT(y)))
#define BITCLEAR(x,y) !BITSET((x), (y))
#define BITSSET(x,y) (((x) & (y)) == (y))
#define BITSCLEAR(x,y) (((x) & (y)) == 0)
#define BITVAL(x,y) (((x)>>(y)) & 1)
*/

#define I2C_LOW(port, bit) sbi(DDR(port),bit)
#define I2C_HIGH(port, bit) cbi(DDR(port),bit)


typedef uint8_t i2cm_state;

#define NOT_INIT   0
#define I2CM_READY 1
#define I2CM_BUSY  2
#define I2CM_SENT  3
#define I2CM_SENT_NO_ACK 4
#define I2CM_SENT_START  5
#define I2CM_SENT_START_NO_ACK 6
#define I2CM_SENT_STOP 7
#define I2CM_RECEIVED_BYTE 8

#define I2CM_DELAY()  _delay_loop_2(4)
#define I2CM_BIT_DELAY() _delay_loop_2(4)

void i2cm_init(void);
void i2cm_manage(void);
uint8_t i2cm_get_state(void);
uint8_t i2cm_get_received_byte(void);
void i2cm_register_event(void (*func)(i2cm_state state));
uint8_t i2cm_send_start(uint8_t sla_w);
uint8_t i2cm_send_stop(void);
uint8_t i2cm_receive_byte(uint8_t last);

uint8_t i2cm_send(uint8_t addr, uint8_t* data, uint8_t len);
uint8_t i2cm_recv(uint8_t addr, uint8_t len);
uint8_t i2cm_get_recv_buffer(uint8_t* buf, uint8_t len);


#define I2C_ERR_SEND_START 1
#define I2C_ERR_SEND_BYTE 2
#define I2C_ERR_RECV_BYTE 3


#endif //I2CM_SW_H
